#
#  plane.rb
#  MazeWarper
#
#  Created by Mayur Pawashe on 8/31/08.
#  Copyright (c) 2008 zgcoder. All rights reserved.
#

class Plane
  attr_accessor :vertex1, :vertex2, :vertex3
  
  def initialize(vertex1, vertex2, vertex3)
    @vertex1, @vertex2, @vertex3 = vertex1, vertex2, vertex3
  end
  
  def distance_from_position(position)
    a = @vertex1.y * (@vertex2.z - @vertex3.z) + @vertex2.y * (@vertex3.z - @vertex1.z) + @vertex3.y * (@vertex1.z - @vertex2.z)
    b = @vertex1.z * (@vertex2.x - @vertex3.x) + @vertex2.z * (@vertex3.x - @vertex1.x) + @vertex3.z * (@vertex1.x - @vertex2.x)
    c = @vertex1.x * (@vertex2.y - @vertex3.y) + @vertex2.x * (@vertex3.y - @vertex1.y) + @vertex3.x * (@vertex1.y - @vertex2.y)
    d = @vertex1.x * (@vertex2.y * @vertex3.z - @vertex3.y * @vertex2.z) + @vertex2.x * (@vertex3.y * @vertex1.z - @vertex1.y * @vertex3.z) + @vertex3.x * (@vertex1.y * @vertex2.z - @vertex2.y * @vertex1.z)
    
    d = -d unless d < 0.0
    
    (a * position.x + b * position.y + c * position.z + d).abs / (Math.sqrt(a * a + b * b + c * c))
  end
end
